
cc.FileUtils:getInstance():setPopupNotify(false)
cc.FileUtils:getInstance():addSearchPath("src/")
cc.FileUtils:getInstance():addSearchPath("res/")

require "config"
require "cocos.init"

local crash_count = 0
-- for CCLuaEngine traceback
function __G__TRACKBACK__(msg)
    local m_msg = "LUA ERROR: \n" .. tostring(msg)
    local trace = debug.traceback()
    local error_msg = m_msg .. trace  
    print(error_msg)
    import("app.util.FileManager")
    import("app.util.TestInUtil")
    local crash_info = {}
    local user_id = UserInfo:getInstance():getUserId()
    local user_name = UserInfo:getInstance():getUserId()
    local version_code = HotFixedManager:getInstance():GetLocalVersion()
    if not user_id or user_id == "" then
        user_id = "unregistered"
    end
    if not user_name then
        user_name = "unregistered"
    end
    crash_info.crash_time = os.time()
    crash_info.crash_msg = error_msg
    crash_info.user_id = tostring(user_id)
    crash_info.user_name = tostring(user_name)

    local opt_type = 'w'
    if crash_count < 10 then
        crash_count = crash_count + 1
        opt_type = 'a+'
    else
        crash_count = 0
        opt_type = 'w'
    end
    if "android" == device.platform then
        FileManager:getInstance():WriteTable2AndroidSync(crash_info, "crash_msg.json", opt_type)
    elseif ("ios" == device.platform) or ("mac" == device.platform)  then
        FileManager:getInstance():WriteTable2JsonFileSync(crash_info, "crash_msg.json", opt_type)
    end


    local crash_string = FileManager:getInstance():ConvertTable2Json(crash_info)
    print("----------------------------------------")
    if __NEED_SEND_TESTIN  then        
        TestInUtil:getInstance():ReportException("lua exp", crash_string)
    end

    if __NEED_SEND_SENTRY then
        TestInUtil:getInstance():SendSentryError(user_id, crash_string,version_code)
    end
    print("----------------------------------------")
end

function __G__LOGTRACE__(msg)
    local opt_type = 'a+'
    if not FileManager then
        import("app.util.FileManager")
    end

    local timestamp = os.time()
    local timedate = os.date("%Y-%m-%d %H:%M:%S",timestamp)
    local crash_info = {}
    crash_info.time = timedate
    crash_info.msg = msg
    if "android" == device.platform then
        FileManager:getInstance():WriteTable2AndroidSync(crash_info, "debug_msg.json", opt_type)
    elseif ("ios" == device.platform) or ("mac" == device.platform)  then
        FileManager:getInstance():WriteTable2JsonFileSync(crash_info, "debug_msg.json", opt_type, true)
    end
end

function _G_LOG(...)
    -- local params = { ... }
    -- print("TYHLOGDETAIL", ...)
end


local function main() 
	collectgarbage("collect")
    -- avoid memory leak
    collectgarbage("setpause", 100)
    collectgarbage("setstepmul", 5000)

    __RELEASE__ = true
	--预定义宏
	__TEST_DEBUG__ = not __RELEASE__
        --强制sdk登录
    __REFORCE_SDKLOGIN__ = __RELEASE__
    --统计支持
    __OPEN_ANASYS__ = __RELEASE__
    --强制注册流程
    __REFORCE_REGISTER__ = __RELEASE__
	--是否需要音乐
    __NEED_BG_MUSIC__ = true
	__NEED_MUSIC__ = true
    __NEED_EFFECT__ = true
	_IS_PRINT_LOG_ = true
    _IS_NEED_NEW_HAND = true
    _IS_NEED_WEATHER = true
    __NEED_SEND_SENTRY = true
    __NEED_SEND_TESTIN = false
    __JAVE_TIME_SHADOW__ = false 
    --热更新开始标识
    __HOT_UPGRADE_FLAG__ = true
    --翻译功能开启控制参数
    __CHAT_TRANSLATER__ = true
    --首次重置奖励模式--
    __AWARD_DIRECT_GET__ = false
    --战斗调试
    __PHYSICS_DEBUG__ = false
    --初始化加载目录
    import("app.hotFixed.HotFixedManager")
    HotFixedManager:getInstance()
	--初始化netCenter
    require("app.MyApp"):create():run()
end

local status, msg = xpcall(main, __G__TRACKBACK__)
if not status then
    print(msg)
end

